## mingw-w64-lpsolve-5.5.2.11-1.src.tar.zst

=== CMakeLists.txt ===
#
# CMakeLists.txt for "lp_solve_5.5.2.0_source.tar.gz"
#
# Copyright 2012-2013 Benjamin Eikel
# Copyright 2018 yumetodo <yume-wikijp@live.jp>
# License: Public Domain
#

cmake_minimum_required(VERSION 2.8.12)

project(lpsolve C)

set(LPSOLVE_VERSION_MAJOR 5)
set(LPSOLVE_VERSION_MINOR 5)
set(LPSOLVE_VERSION_PATCH 2)
set(LPSOLVE_VERSION ${LPSOLVE_VERSION_MAJOR}.${LPSOLVE_VERSION_MINOR}.${LPSOLVE_VERSION_PATCH})
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)
option(LIB_TYPE "STATIC or SHARED" SHARED)

# Set up install directories
include(GNUInstallDirs)
set(CMAKE_INSTALL_CMAKECONFIGDIR ${CMAKE_INSTALL_LIBDIR}/cmake/lpsolve)

add_library(lpsolve55 ${LIB_TYPE}
    lp_MDO.c
    shared/commonlib.c
    shared/mmio.c
    shared/myblas.c
    ini.c
    fortify.c
    colamd/colamd.c
    lp_rlp.c
    lp_crash.c
    bfp/bfp_LUSOL/lp_LUSOL.c
    bfp/bfp_LUSOL/LUSOL/lusol.c
    lp_Hash.c
    lp_lib.c
    lp_wlp.c
    lp_matrix.c
    lp_mipbb.c
    lp_MPS.c
    lp_params.c
    lp_presolve.c
    lp_price.c
    lp_pricePSE.c
    lp_report.c
    lp_scale.c
    lp_simplex.c
    lp_SOS.c
    lp_utils.c
    yacc_read.c
)

set_property(TARGET lpsolve55 PROPERTY PUBLIC_HEADER
    lp_bit.h
    lp_crash.h
    lp_explicit.h
    lp_fortify.h
    lp_Hash.h
    lp_lib.h
    lp_matrix.h
    lp_MDO.h
    lp_mipbb.h
    lp_MPS.h
    lp_presolve.h
    lp_price.h
    lp_pricePSE.h
    lp_report.h
    lp_rlp.h
    lp_scale.h
    lp_simplex.h
    lp_solveDLL.h
    lp_SOS.h
    lp_types.h
    lp_utils.h
    lp_wlp.h
)

target_include_directories(lpsolve55 PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_CURRENT_SOURCE_DIR}/shared"
    "${CMAKE_CURRENT_SOURCE_DIR}/bfp"
    "${CMAKE_CURRENT_SOURCE_DIR}/bfp/bfp_LUSOL"
    "${CMAKE_CURRENT_SOURCE_DIR}/bfp/bfp_LUSOL/LUSOL"
    "${CMAKE_CURRENT_SOURCE_DIR}/colamd"
)

target_compile_definitions(lpsolve55 PUBLIC
    YY_NEVER_INTERACTIVE
    PARSER_LP
    INVERSE_ACTIVE=INVERSE_LUSOL
    RoleIsExternalInvEngine
)

if(WIN32)
    target_compile_definitions(lpsolve55 PUBLIC
        INLINE=static
        _USRDLL
        WIN32
    )
endif()

include(CheckSymbolExists)
check_symbol_exists(isnan math.h HAVE_ISNAN)
if(NOT HAVE_ISNAN)
    set_property(TARGET lpsolve55 APPEND PROPERTY COMPILE_DEFINITIONS NOISNAN)
endif()

include (CheckLibraryExists)
check_library_exists(m ceil "" HAVE_LIBM)
if (HAVE_LIBM)
  target_link_libraries (lpsolve55 PUBLIC m)
endif ()

check_library_exists(dl dlopen "" HAVE_LIBDL)
if (HAVE_LIBDL)
  target_link_libraries (lpsolve55 PUBLIC dl)
endif ()

# Set version of library
set_target_properties(lpsolve55 PROPERTIES VERSION ${LPSOLVE_VERSION}
                                           SOVERSION ${LPSOLVE_VERSION_MAJOR})

# Install the library
install(TARGETS lpsolve55 EXPORT lpsolve55-export
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/lpsolve
)

# Set include directories for users of this library
target_include_directories(lpsolve55 INTERFACE ${CMAKE_INSTALL_FULL_INCLUDEDIR}/lpsolve)

# Library export
install(EXPORT lpsolve55-export DESTINATION ${CMAKE_INSTALL_CMAKECONFIGDIR} FILE lpsolveTargets.cmake)

# Create the configuration files
include(CMakePackageConfigHelpers)
get_property(LPSOLVE_DEFINITIONS TARGET lpsolve55 PROPERTY COMPILE_DEFINITIONS)
configure_package_config_file(lpsolveConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/lpsolveConfig.cmake
                              INSTALL_DESTINATION ${CMAKE_INSTALL_CMAKECONFIGDIR}
                              PATH_VARS CMAKE_INSTALL_CMAKECONFIGDIR
                              NO_SET_AND_CHECK_MACRO
                              NO_CHECK_REQUIRED_COMPONENTS_MACRO)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/lpsolveConfigVersion.cmake
                                 VERSION ${LPSOLVE_VERSION}
                                 COMPATIBILITY SameMajorVersion)

# Install the configuration files
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lpsolveConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/lpsolveConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_CMAKECONFIGDIR})

# lpsolve front-end
if(${LIB_TYPE} STREQUAL "STATIC")
    add_executable (lp_solve lp_solve/lp_solve.c)
    target_include_directories(lp_solve PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")
    target_link_libraries (lp_solve PUBLIC lpsolve55)
    install (TARGETS lp_solve DESTINATION bin)
endif()

# for xxx-config.cmake
install(EXPORT lpsolve55-export
    FILE lpsolve55-config.cmake
    DESTINATION share/cmake/lpsolve55/
    EXPORT_LINK_INTERFACE_LIBRARIES)

=== PKGBUILD ===
# Maintainer: yumetodo <yume-wikijp@live.jp>

_realname=lpsolve
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.5.2.11
pkgrel=1
pkgdesc="Mixed Integer Linear Programming (MILP) solver (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
url="https://sourceforge.net/projects/lpsolve/"
license=('spdx:LGPL-2.1-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake" "${MINGW_PACKAGE_PREFIX}-cc")
source=("https://downloads.sourceforge.net/project/${_realname}/${_realname}/${pkgver}/lp_solve_${pkgver}_source.tar.gz"
        "CMakeLists.txt"
        "lpsolveConfig.cmake.in"
        "avoid_undefined_reference.patch")
sha256sums=('6d4abff5cc6aaa933ae8e6c17a226df0fc0b671c438f69715d41d09fe81f902f'
            'b37e745e83b1a3e7b3a282fc0ffbb60f0a29fc4ca7533e3e97f10e21c6ae0ecd'
            '11e739b216ba402ae6af1e3a6bcf281f5bbb859ef0521362e82ac583a723d97d'
            '0737fc393b2791089dc87cb546494fc6957725da36423e22a4ab4e80f929db48')

prepare() {
  cd "${srcdir}/lp_solve_5.5"
  cp "${srcdir}/CMakeLists.txt" .
  cp "${srcdir}/lpsolveConfig.cmake.in" .
  patch -p0 -i "${srcdir}/avoid_undefined_reference.patch"
}

build() {
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  # shared build
  [[ -d ${srcdir}/build-${MSYSTEM}-shared ]] && rm -rf ${srcdir}/build-${MSYSTEM}-shared
  mkdir -p ${srcdir}/build-${MSYSTEM}-shared && cd ${srcdir}/build-${MSYSTEM}-shared
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"MSYS Makefiles" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ${extra_config} \
    -DLIB_TYPE=SHARED \
    ../lp_solve_5.5
  make

  # static build
  [[ -d ${srcdir}/build-${MSYSTEM}-static ]] && rm -rf ${srcdir}/build-${MSYSTEM}-static
  mkdir -p ${srcdir}/build-${MSYSTEM}-static && cd ${srcdir}/build-${MSYSTEM}-static
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"MSYS Makefiles" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ${extra_config} \
    -DLIB_TYPE=STATIC \
    ../lp_solve_5.5
  make
}

package() {
  # Shared Install
  cd "${srcdir}/build-${MSYSTEM}-shared"
  make DESTDIR="${pkgdir}" install

  # Static Install
  cd "${srcdir}/build-${MSYSTEM}-static"
  make DESTDIR="${pkgdir}" install
}

warn_build_references() {
  : # I like __FILE__ and don't consider build references to be a problem
}
